<template>
  <div class="signup">
    <div class="signup-content">
      <div class="signup-title">
        <span class="title-text">wPlay</span>
        <img class="title-logo" src="@/assets/images/wplay_logo.svg" alt="" height="50px">
      </div>
      <div class="signup-form">
        <div class="form-field"
            :class="{'form-field--active': inputState.login === InputStates.active}">
          <label class="form-label" for="form-login">Логин</label>
          <input id="form-login" class="form-input" v-model="login" type="text"
            placeholder="Введите логин" @keydown.enter="submit"
            @focus="changeInputState('login', InputStates.active)"
            @blur="changeInputState('login', InputStates.default)">
        </div>
        <div class="form-field"
            :class="{'form-field--active': inputState.password === InputStates.active}">
          <label class="form-label" for="form-password">Пароль</label>
          <input id="form-password" class="form-input" v-model="password" type="password"
            placeholder="Введите пароль" @keydown.enter="submit"
            @focus="changeInputState('password', InputStates.active)"
            @blur="changeInputState('password', InputStates.default)">
        </div>
        <div class="form-field"
            :class="{'form-field--active': inputState.passwordRepeat === InputStates.active}">
          <label class="form-label" for="form-password_repeat">Повторите пароль</label>
          <input id="form-password_repeat" class="form-input" v-model="passwordRepeat"
            type="password" placeholder="Повторите пароль" @keydown.enter="submit"
            @focus="changeInputState('passwordRepeat', InputStates.active)"
            @blur="changeInputState('passwordRepeat', InputStates.default)">
        </div>
        <div class="form-field"
            :class="{'form-field--active': inputState.code === InputStates.active}">
          <label class="form-label" for="form-code">Код регистрации</label>
          <input id="form-code" class="form-input" v-model="code"
            type="text" placeholder="Введите код" @keydown.enter="submit"
            @focus="changeInputState('code', InputStates.active)"
            @blur="changeInputState('code', InputStates.default)">
        </div>
        <div class="form-actions">
          <button class="form-button" @click="submit"
            :disabled="!isSubmitAllowed">
            Зарегистрироваться
          </button>
        </div>
      </div>
    </div>
  </div>
</template>

<script>
import { mapActions, mapGetters } from 'vuex';

const InputStates = {
  default: 0,
  active: 1,
  error: 2,
};

export default {
  name: 'Registration',
  data() {
    return {
      login: '',
      password: '',
      passwordRepeat: '',
      code: '',
      inputState: {
        login: InputStates.default,
        password: InputStates.default,
        passwordRepeat: InputStates.default,
        code: InputStates.default,
      },
      InputStates,
    };
  },
  computed: {
    ...mapGetters('session', ['isAuthorized']),
    isSubmitAllowed() {
      return this.login.length > 0
        && this.password.length > 0
        && this.password === this.passwordRepeat
        && this.code === 'mDuCvT6zJg';
    },
  },
  methods: {
    ...mapActions('session', ['register', 'getAuthorizedUser']),
    changeInputState(fieldName, state) {
      this.inputState[fieldName] = state;
    },
    async submit() {
      if (!this.isSubmitAllowed) return;
      try {
        await this.register({
          email: this.login,
          surname: this.login,
          name: this.login,
          patronymic: this.login,
          password: this.password,
        });
        this.$toasted.success('Регистрация успешна');
        this.$router.replace({ name: 'login' });
      } catch (errors) {
        if (errors.length) {
          errors.forEach((err) => {
            this.$toasted.error(err.message);
          });
        } else {
          this.$toasted.error('Неизветсная ошибка');
        }
      }
    },
  },
  mounted() {
    this.getAuthorizedUser();
    if (this.isAuthorized) {
      this.$router.replace({ name: 'portal' });
    }
  },
};
</script>

<style lang="scss" scoped>
.signup {
  width: 100vw;
  height: 100vh;
  display: flex;
  justify-content: center;
  align-items: center;
  background: #fff;

  &-content {
    width: 440px;
    height: 350px;
    display: flex;
    flex-direction: column;
    justify-content: flex-start;
    align-items: stretch;
  }

  &-title {
    display: flex;
    justify-content: center;
    align-items: center;

    .title {

      &-text {
        color: #000;
        font-size: 60px;
        font-family: $firaSans;
      }

      &-logo {
        margin-left: 11px;
      }

    }

  }

  &-form {

    > div {
      margin-top: 28px;
    }

    .form {

      &-field {
        position: relative;
        padding: 14px 13px 0 13px;
        height: 40px;
        border: 1px solid $neutralDark;
        border-radius: 5px;
        transition: border ease-in-out .2s;

        &--active {
          border: 1px solid #000;

          .form-label {
            color: #000 !important;
          }

        }

        .form-label {
          position: absolute;
          top: -11px;
          left: 10px;
          padding: 0 10px 0 4px;
          color: $neutralDarker;
          background: #fff;
          font-size: 18px;
          font-family: $firaSans;
          transition: color ease-in-out .2s;
        }

        .form-input {
          margin-top: 5px;
          width: 100%;
          color: #000;
          font-size: 24px;
          font-family: $roboto;
          border: none;
          outline: none;

          &::placeholder {
            color: $neutralDarker;
          }

        }

      }

      &-actions {

        .form-button {
          height: 54px;
          width: 100%;
          color: #fff;
          background: $primary;
          font-size: 24px;
          font-family: $firaSans;
          border: none;
          border-radius: 5px;
          transition: background ease-in-out .2s;

          &:hover {
            background: $primaryDark;
            cursor: pointer;
          }

          &:disabled {
            background: $neutralDarker;
            cursor: not-allowed;
          }

        }

      }

    }

  }

}
</style>
